您的位置:首页 > 其它

HDU 4336 Card Collector(状压枚举+概率dp)

2014-07-09 20:34 253 查看
题目大意:有N(1<=N<=20)张卡片,每包中含有这些卡片的概率为p1,p2,````pN.每包至多一张卡片,可能没有卡片。求需要买多少包才能拿到所以的N张卡片,求次数的期望。

解题思路:状压枚举每个包开出来的卡片的情况。然后在经行dp。

PS:和省赛的热身赛的题目像极了啊、、


Card Collector

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 32768/32768 K (Java/Others)

Total Submission(s): 2243    Accepted Submission(s): 1058
Special Judge


Problem Description

In your childhood, do you crazy for collecting the beautiful cards in the snacks? They said that, for example, if you collect all the 108 people in the famous novel Water Margin, you will win an amazing award. 

As a smart boy, you notice that to win the award, you must buy much more snacks than it seems to be. To convince your friends not to waste money any more, you should find the expected number of snacks one should buy to collect a full suit of cards.

 

Input

The first line of each test case contains one integer N (1 <= N <= 20), indicating the number of different cards you need the collect. The second line contains N numbers p1, p2, ..., pN, (p1 + p2 + ... + pN <= 1), indicating the possibility of each card to
appear in a bag of snacks. 

Note there is at most one card in a bag of snacks. And it is possible that there is nothing in the bag.

 

Output

Output one number for each test case, indicating the expected number of bags to buy to collect all the N different cards.

You will get accepted if the difference between your answer and the standard answer is no more that 10^-4.

 

Sample Input

1
0.1
2
0.1 0.4

 

Sample Output

10.000
10.500

 

#include <algorithm>
#include <iostream>
#include <stdlib.h>
#include <string.h>
#include <iomanip>
#include <stdio.h>
#include <string>
#include <queue>
#include <cmath>
#include <stack>
#include <map>
#include <set>
#define eps 1e-7
//#define M 1000100
//#define LL __int64
#define LL long long
#define INF 0x3f3f3f3f
#define PI 3.1415926535898

const int maxn = 21;

using namespace std;

double dp[1<<(maxn)];
double p[maxn];
int n;

int main()
{
while(cin >>n)
{
p[0] = 0.0;
for(int i = 1; i <= n; i++)
{
cin >>p[i];
p[0] += p[i];
}
p[0] = 1-p[0];
dp[(1<<n)-1] = 0;
for(int i = (1<<n)-2; i >= 0; i--)
{
double x = p[0];
dp[i] = 1.0;
for(int j = 0; j < n; j++)
{
if(!((1<<j)&i))
dp[i] += (dp[i+(1<<j)])*(p[j+1]);
else
x += p[j+1];
}
dp[i] /= (1-x);
}
printf("%.5lf\n",dp[0]);
}
return 0;
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: